Index: main/manager.c
===================================================================
--- main/manager.c	(revision 290682)
+++ main/manager.c	(working copy)
@@ -1978,11 +1978,11 @@
 {
 	int maskint = strings_to_mask(eventmask);
 
-	mansession_lock(s);
+	ao2_lock(s->session);
 	if (maskint >= 0) {
 		s->session->send_events = maskint;
 	}
-	mansession_unlock(s);
+	ao2_unlock(s->session);
 
 	return maskint;
 }
@@ -2771,7 +2771,7 @@
 		/* XXX maybe put an upper bound, or prevent the use of 0 ? */
 	}
 
-	mansession_lock(s);
+	ao2_lock(s->session);
 	if (s->session->waiting_thread != AST_PTHREADT_NULL) {
 		pthread_kill(s->session->waiting_thread, SIGURG);
 	}
@@ -2795,14 +2795,14 @@
 			s->session->send_events = -1;
 		}
 	}
-	mansession_unlock(s);
+	ao2_unlock(s->session);
 
 	/* XXX should this go inside the lock ? */
 	s->session->waiting_thread = pthread_self();	/* let new events wake up this thread */
 	ast_debug(1, "Starting waiting for an event!\n");
 
 	for (x = 0; x < timeout || timeout < 0; x++) {
-		mansession_lock(s);
+		ao2_lock(s->session);
 		if (AST_RWLIST_NEXT(s->session->last_ev, eq_next)) {
 			needexit = 1;
 		}
@@ -2816,7 +2816,7 @@
 		if (s->session->needdestroy) {
 			needexit = 1;
 		}
-		mansession_unlock(s);
+		ao2_unlock(s->session);
 		if (needexit) {
 			break;
 		}
@@ -2830,7 +2830,7 @@
 	}
 	ast_debug(1, "Finished waiting for an event!\n");
 
-	mansession_lock(s);
+	ao2_lock(s->session);
 	if (s->session->waiting_thread == pthread_self()) {
 		struct eventqent *eqe = s->session->last_ev;
 		astman_send_response(s, m, "Success", "Waiting for Event completed.");
@@ -2851,7 +2851,8 @@
 	} else {
 		ast_debug(1, "Abandoning event request!\n");
 	}
-	mansession_unlock(s);
+	ao2_unlock(s->session);
+
 	return 0;
 }
 
@@ -4544,21 +4545,20 @@
 	}
 	res = 0;
 	while (res == 0) {
-		/* XXX do we really need this locking ? */
-		mansession_lock(s);
+		ao2_lock(s->session);
 		if (s->session->pending_event) {
 			s->session->pending_event = 0;
-			mansession_unlock(s);
+			ao2_unlock(s->session);
 			return 0;
 		}
 		s->session->waiting_thread = pthread_self();
-		mansession_unlock(s);
+		ao2_unlock(s->session);
 
 		res = ast_wait_for_input(s->session->fd, -1);	/* return 0 on timeout ? */
 
-		mansession_lock(s);
+		ao2_lock(s->session);
 		s->session->waiting_thread = AST_PTHREADT_NULL;
-		mansession_unlock(s);
+		ao2_unlock(s->session);
 	}
 	if (res < 0) {
 		/* If we get a signal from some other thread (typically because
@@ -4571,7 +4571,7 @@
 		return -1;
 	}
 
-	mansession_lock(s);
+	ao2_lock(s->session);
 	res = fread(src + s->session->inlen, 1, maxlen - s->session->inlen, s->session->f);
 	if (res < 1) {
 		res = -1;	/* error return */
@@ -4580,7 +4580,7 @@
 		src[s->session->inlen] = '\0';
 		res = 0;
 	}
-	mansession_unlock(s);
+	ao2_unlock(s->session);
 	return res;
 }
 
